--|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
function CheckShopChest(IN_world, IN_x, IN_y, IN_z)			-- RETURNS WHAT IS IN THE CHEST AND IN WHICH AMMOUNT
	local ReadChest = function (Chest)
		-- stalk through chest slots...
		local _slot_counter = 0
		local _slot_item
		while true do
			_slot_item = Chest:GetSlot(_slot_counter)
			if (_slot_item ~= nil) then
				if (_slot_item.m_ItemID ~= E_ITEM_EMPTY) then
					if (_result[1] ~= -1) then
						if (_result[1] ~= _slot_item.m_ItemID) then
							_result[1] = -2
							break
						end
					else
						_result[1] = _slot_item.m_ItemID
					end
					_result[2] = _result[2] + _slot_item.m_ItemCount
				end
			end
			_slot_counter = _slot_counter + 1
			if (_slot_counter == CHEST_WIDTH*HANDY:Call("GetChestHeightCheat", Chest)) then
				break
			end
		end
	end
	_result = {}
	_result[1] = -1
	_result[2] = 0
	IN_world:DoWithChestAt(IN_x, IN_y, IN_z, ReadChest)
	return _result
end

function CheckCashMachineChest(IN_world, IN_x, IN_y, IN_z)	-- we just want to know if it's even there :D
	local ReadChest = function (Chest)
		_result = 1
	end
	_result = 0
	IN_world:DoWithChestAt(IN_x, IN_y, IN_z, ReadChest)
	return _result
end

function RegisterShop(IN_world, IN_ownername, IN_x, IN_y, IN_z, IN_itemID, IN_ammount, IN_tochest, IN_fromchest, IN_fractional_trade)
	local _adress = GetAdress(IN_world, IN_x, IN_y, IN_z)
	if (ShopsData[_adress] == nil)				then ShopsData[_adress] = {} end
	
	ShopsData[_adress].x = IN_x
	ShopsData[_adress].y = IN_y
	ShopsData[_adress].z = IN_z
	
	ShopsData[_adress].item = IN_itemID
	ShopsData[_adress].ammount = IN_ammount
	ShopsData[_adress].tochest = IN_tochest
	ShopsData[_adress].fromchest = IN_fromchest
	ShopsData[_adress].world = IN_world	-- NOT A NAME!
	ShopsData[_adress].ownername = IN_ownername
	ShopsData[_adress].fractional = IN_fractional_trade
	
	if (TradersData[IN_ownername] == nil) then
		TradersData[IN_ownername] = {}
	end
end

function RegisterCashMachine(IN_world, IN_ownername, IN_x, IN_y, IN_z)
	if (TradersData[IN_ownername] == nil) then
		TradersData[IN_ownername] = {}
	end
	if (TradersData[IN_ownername].cashmachine == nil) then
		TradersData[IN_ownername].cashmachine = {}
	end
	TradersData[IN_ownername].cashmachine.x = IN_x
	TradersData[IN_ownername].cashmachine.y = IN_y
	TradersData[IN_ownername].cashmachine.z = IN_z
	TradersData[IN_ownername].cashmachine.world = IN_world
end
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
--/ / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / / /
function GetFromShop(IN_world, Player, IN_x, IN_y, IN_z)
	local GetItemsFromChest = function (Chest)
		local _c_balance, _c_free_space = HANDY:Call("ReadChestForItem", Chest, ShopsData[_adress].item)
		_trade_count = math.min(_trade_count, _c_balance)
		if (_trade_count ~= ShopsData[_adress].ammount) then
			if (ShopsData[_adress].fractional == false)	then	--													<<< miniDOOMSDAY DEVICE
				return 0
			end
		end
		HANDY:Call("TakeItemsFromChest", Chest, ShopsData[_adress].item, _trade_count)
	end
	_adress = GetAdress(IN_world, IN_x, IN_y, IN_z)
	local _result = 0	-- will contain ammount of traded items
	OPERATION_STATE.success = false
	OPERATION_STATE.partial = false
	
	if (ShopsData[_adress] ~= nil) then
		if (ShopsData[_adress].fromchest ~= -1) then
			_trade_count = 1
			local _transfer_item = cItem(ShopsData[_adress].item, _trade_count)
			local _fractional_trade = ShopsData[_adress].fractional
			OPERATION_STATE.itemID = ShopsData[_adress].item
			OPERATION_STATE.merchantname = ShopsData[_adress].ownername
			OPERATION_STATE.performed = true
			
			-- 1. Check, how much items player could afford; how much items merchant could sell (cash machine storage has limits!)
			local _unit_price = (ShopsData[_adress].fromchest/ShopsData[_adress].ammount)
			local _p_balance, _p_free_space = GetPlayerTradeData(Player:GetName())
			local _m_balance, _m_free_space = GetMerchantTradeData(ShopsData[_adress].ownername)
			local _player_can_buy = math.floor(_p_balance/_unit_price)
			local _merchant_can_sell = math.floor(_m_free_space/_unit_price)
			if (_m_free_space == -1)	then	_merchant_can_sell = ShopsData[_adress].ammount	end
			_trade_count = math.min(_player_can_buy, _merchant_can_sell)
			if (_player_can_buy < ShopsData[_adress].ammount) then
				OPERATION_STATE.partial = true
				OPERATION_STATE.fail_reason = FAIL_REASON.player_no_money
				if (_fractional_trade == false)	then	--															<<< DOOMSDAY DEVICE
					return 0
				end
			end
			if (_merchant_can_sell < ShopsData[_adress].ammount) then
				OPERATION_STATE.partial = true
				OPERATION_STATE.fail_reason = FAIL_REASON.merchant_no_space
				if (_fractional_trade == false)	then	--															<<< DOOMSDAY DEVICE
					return 0
				end
			end
			-- 1.1 Also check how much items player could hold!
			_p_balance, _p_free_space = HANDY:Call("ReadPlayerForItem", Player, ShopsData[_adress].item)
			_trade_count = math.min(_p_free_space, _trade_count)
			if (_trade_count < ShopsData[_adress].ammount) then
				OPERATION_STATE.partial = true
				OPERATION_STATE.fail_reason = FAIL_REASON.player_no_space
				if (_fractional_trade == false)	then	--															<<< DOOMSDAY DEVICE
					return 0
				end
			end
			_trade_count = math.min(ShopsData[_adress].ammount, _trade_count)
			
			-- 2. Remove as much items from chest, as possible.
			IN_world:DoWithChestAt(IN_x, IN_y - 1, IN_z, GetItemsFromChest)
			-- _trade_count now contain ammount of traded items
			if (_trade_count ~= ShopsData[_adress].ammount) then
				OPERATION_STATE.partial = true
				OPERATION_STATE.fail_reason = FAIL_REASON.not_enough_items
				if (_fractional_trade == false)	then	--															<<< DOOMSDAY DEVICE
					return 0
				end
			end
			
			-- 3. Charge player.
			MakeTransaction(Player:GetName(), ShopsData[_adress].ownername, _trade_count*_unit_price, true)
			
			-- 4. Add items to player.
			_result = _trade_count
			HANDY:Call("GiveItemsToPlayer", Player, ShopsData[_adress].item, _trade_count)
			OPERATION_STATE.success = true
			OPERATION_STATE.ammount = _result
			OPERATION_STATE.money_ammount = _result*_unit_price
		end
	else
		--LOG("FAIL! There's no shop")
	end
	_chest = nil
	return _result
end
function SellToShop(IN_world, Player, IN_x, IN_y, IN_z)
	local _result = 0
	return _result
end
--\ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \ \
--///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
function GetMerchantTradeData(IN_merchantname)
	local CheckCashMachine = function (Chest)
		_balance, _free_space = HANDY:Call("ReadChestForItem", Chest, BarterItem)
	end
	_balance = 0
	_free_space = 0
	
	if (BARTER == false) then
		_balance = COINY:Call("GetMoney", IN_merchantname)
		_free_space = -1	-- makes no sense, but still...
	else
		if (TradersData[IN_merchantname] ~= nil) then
			if (TradersData[IN_merchantname].cashmachine ~= nil) then
				local _x = TradersData[IN_merchantname].cashmachine.x
				local _y = TradersData[IN_merchantname].cashmachine.y -1
				local _z = TradersData[IN_merchantname].cashmachine.z
				TradersData[IN_merchantname].cashmachine.world:DoWithChestAt(_x, _y, _z, CheckCashMachine)
			end
		end
	end
	return _balance, _free_space
end

function GetPlayerTradeData(IN_playername)
	_balance = 0
	_free_space = 0
	local _player = HANDY:Call("GetPlayerByName", IN_playername)
	if (BARTER == false) then
		_balance = COINY:Call("GetMoney", IN_playername)
		_free_space = -1	-- makes no sense, but still...
	else
		_balance, _free_space = HANDY:Call("ReadPlayerForItem", _player, BarterItem)
	end
	return _balance, _free_space
end

function MakeTransaction(IN_playername, IN_merchantname, IN_ammount, IN_operation_fromchest)	-- UNSAFE, CHECK FIRST
	if (BARTER == false) then
		COINY:Call("TransferMoney", IN_playername, IN_merchantname, tonumber(IN_ammount))
	else
		-- coins, coins everywhere!
		local OperateCashMachine = function (Chest)
			if (IN_operation_fromchest == true) then
				HANDY:Call("PutItemsToChest", Chest, BarterItem, IN_ammount)
			else
				HANDY:Call("TakeItemsFromChest", Chest, BarterItem, IN_ammount)
			end
		end
		local _player = HANDY:Call("GetPlayerByName", IN_playername)
		local _merchant = HANDY:Call("GetPlayerByName", IN_merchantname)
		
		-- 1. Make operations with cash machine
		local _x = TradersData[IN_merchantname].cashmachine.x
		local _y = TradersData[IN_merchantname].cashmachine.y -1
		local _z = TradersData[IN_merchantname].cashmachine.z
		TradersData[IN_merchantname].cashmachine.world:DoWithChestAt(_x, _y, _z, OperateCashMachine)
		
		-- 2. Make operations with pockets
		if (IN_operation_fromchest == true) then
			HANDY:Call("TakeItemsFromPlayer", _player, BarterItem, _trade_count)
		else
			HANDY:Call("GiveItemsToPlayer", _player, BarterItem, _trade_count)
		end
	end
end
--|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||
-- splits line by any desired symbol
function LineSplit(pString, pPattern)		-- THANK YOU, stackoverflow!
	local Table = {}  -- NOTE: use {n = 0} in Lua-5.0
	local fpat = "(.-)" .. pPattern
	local last_end = 1
	local s, e, cap = pString:find(fpat, 1)
	while s do
		if s ~= 1 or cap ~= "" then
			table.insert(Table,cap)
		end
		last_end = e+1
		s, e, cap = pString:find(fpat, last_end)
	end
	if last_end <= #pString then
		cap = pString:sub(last_end)
		table.insert(Table, cap)
	end
	return Table
end

function GetAdress(IN_world, IN_x, IN_y, IN_z)
	return IN_world:GetName().." x:"..tostring(IN_x).." y:"..tostring(IN_y).." z:"..tostring(IN_z)
end