-- Global variables
PLUGIN = {}	-- Reference to own plugin object
HANDY = {}
COINY = {}
CHEST_WIDTH = 9
-- LOGICS
ShopsData = {}
TradersData = {}
-- SETTINGS
FRACTIONAL_TRADE = true
BARTER = true
BarterItem = E_ITEM_GOLD_NUGGET
-- MESSAGES
MESSAGES = {}
MESSAGES.success = "Success!"
MESSAGES.partial_transfer = "Operation wasn't performed completely, but we did our best to please you!"

MESSAGES.aborted_partial_transfer = "Fractional operations are disallowed server-wise"
MESSAGES.banned_partial_transfer = "Fractional operations are disallowed by merchant"
MESSAGES.merchant_no_space = "Merchant can't take your coins("
MESSAGES.to_merchant_no_space = "Hey, you, free your cash machine a bit, uh? Someone can't shut you up and give his money!"
MESSAGES.player_no_money = "You can't afford it"
MESSAGES.player_no_space = "You don't have SPAAAAAACE!"
MESSAGES.no_items_in_shop = "Out of stock"

FAIL_REASON = {}
FAIL_REASON.aborted_partial_transfer = 0	-- aborted due to server-wise setting
FAIL_REASON.banned_partial_transfer = 1		-- means it was banned by merchant
FAIL_REASON.merchant_no_space = 2			-- overloaded cash machine
FAIL_REASON.player_no_money = 3
FAIL_REASON.player_no_space = 4
FAIL_REASON.no_items_in_shop = 5

OPERATION_STATE = {}
OPERATION_STATE.performed = false
OPERATION_STATE.success = true
OPERATION_STATE.fail_reason = FAIL_REASON.player_no_money
OPERATION_STATE.partial = false
OPERATION_STATE.ammount = 0
OPERATION_STATE.money_ammount = 0
OPERATION_STATE.itemID = 0
OPERATION_STATE.merchantname = ""
--[[
TODO:
- too much to write, lol
]]
function Initialize(Plugin)
	PLUGIN = Plugin
	PLUGIN:SetName("Trady")
	PLUGIN:SetVersion(4)
	
	PluginManager = cRoot:Get():GetPluginManager()
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_PLAYER_LEFT_CLICK)
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_PLAYER_RIGHT_CLICK)
	PluginManager:AddHook(PLUGIN, cPluginManager.HOOK_UPDATING_SIGN)
	HANDY = PluginManager:GetPlugin("Handy")
	COINY = PluginManager:GetPlugin("Coiny")
	
	--Plugin:AddWebTab("Trady", HandleRequest_ChestShop)
	
	LOG("Initialized " .. PLUGIN:GetName() .. " v" .. PLUGIN:GetVersion())
	return true
end

function OnDisable()
	LOG(PLUGIN:GetName() .. " v" .. PLUGIN:GetVersion() .. " is shutting down...")
end

function OnUpdatingSign(World, BlockX, BlockY, BlockZ, Line1, Line2, Line3, Line4, Player)
	local _ownername = Player:GetName()
	if (Line4 == "") then
		local _split = LineSplit(Line1, "\:")
		if (#_split == 2) then
			local _from_chest_price = tonumber(_split[1])	-- player buys something from chest
			local _to_chest_price = tonumber(_split[2])		-- player sells something to chest
			local _ammount_override = -1
			if (Line2 ~= "") then	_ammount_override = tonumber(Line2)	end
			local _fractional_trade = (FRACTIONAL_TRADE and (not HANDY:Call("StringToBool", Line3)))
			
			Line1 = ""
			Line2 = ""
			Line3 = ""
			Line4 = ""
			
			local _check = {}
			_check = CheckShopChest(Player:GetWorld(), BlockX, BlockY - 1, BlockZ)
			if (_check[1] >= 0) then
				Line1 = ItemTypeToString(_check[1])
				Line2 = _check[2].." pieces"
				Line3 = "/\\".._split[1].."  ".._split[2].."\\/"
				if (_split[1] == "-") then
					_from_chest_price = -1
				end
				if (_split[2] == "-") then
					_to_chest_price = -1
				end
				Line4 = Player:GetName()
				if (_ammount_override > 0) then		_check[2] = _ammount_override	end
				RegisterShop(Player:GetWorld(), Player:GetName(), BlockX, BlockY, BlockZ, _check[1], _check[2], _to_chest_price, _from_chest_price, _fractional_trade)
				LOG(PLUGIN:GetName().." reporting: created a shop at ("..BlockX..":"..BlockY..":"..BlockZ..") by ".._ownername)
			elseif (_check[1] == -2) then
				Player:SendMessage("Shop wasn't created due to mixed items in chest")
			elseif (_check[1] == -1) then
				Player:SendMessage("Fill chest with items you want to sell first")
			end
		end
	end
	-- now we got to check for cash machine!
	if (BARTER == true) then
		if (Line2 == ""
		and Line3 == ""
		and Line4 == "") then
			if (Line1 == "cash") then
				Line1 = ""
				Line2 = ""
				Line3 = ""
				Line4 = ""
				
				if (CheckCashMachineChest(Player:GetWorld(), BlockX, BlockY - 1, BlockZ) == 1) then
					-- OK, there's a chest and we got a sign, let's turn it into motherfucking CASH MACHINE!
					Line1 = "Cash Machine"
					Line3 = "belong to"
					Line4 = _ownername
					RegisterCashMachine(Player:GetWorld(), Player:GetName(), BlockX, BlockY, BlockZ)
					LOG(PLUGIN:GetName().." reporting: created a cash machine at ("..BlockX..":"..BlockY..":"..BlockZ..") by ".._ownername)
				else
					Player:SendMessage("There's no fucking chest, how are you supposed to keep your piles of... whatever?!")
				end
			end
		end
	end
    return false, Line1, Line2, Line3, Line4
end
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
-- LEFTCLICK!
function OnPlayerLeftClick(Player, BlockX, BlockY, BlockZ, BlockFace, Status)
	SellToShop(Player:GetWorld(), Player, IN_x, IN_y, IN_z)
	return false
end

-- RIGHTCLICK!
function OnPlayerRightClick(Player, BlockX, BlockY, BlockZ, BlockFace, CursorX, CursorY, CursorZ)
	if (IN_x ~= -1 and IN_y ~= 255 and IN_z ~= -1) then
		_items_traded = GetFromShop(Player:GetWorld(), Player, IN_x, IN_y, IN_z)
		if (_items_traded ~= 0) then
			if (OPERATION_STATE.partial == true) then
				Player:SendMessage(MESSAGES.partial_transfer)
			end
			local _itemname = HANDY:Call("PluralItemName", OPERATION_STATE.itemID, OPERATION_STATE.ammount)
			local _price = OPERATION_STATE.money_ammount
			if (BARTER == false) then
				_price = _price.." "..HANDY:Call("PluralString", OPERATION_STATE.money_ammount, " coin", " coins")
			else
				_price = _price.." "..HANDY:Call("PluralItemName", BarterItem, OPERATION_STATE.money_ammount)
			end
			Player:SendMessage("Bought "..OPERATION_STATE.ammount.." ".._itemname.." for ".._price..", from "..OPERATION_STATE.merchantname)
			return true
		else
			LOGWARN("Nothing traded")
			if (OPERATION_STATE.performed == true) then
				OPERATION_STATE.performed = false
				if (OPERATION_STATE.success == false) then
					if (OPERATION_STATE.fail_reason 				== FAIL_REASON.merchant_no_space)			then
						Player:SendMessage(MESSAGES.merchant_no_space)
						HANDY:Call("GetPlayerByName", OPERATION_STATE.merchantname):SendMessage(MESSAGES.to_merchant_no_space)
					elseif (OPERATION_STATE.fail_reason 				== FAIL_REASON.player_no_money)				then
						Player:SendMessage(MESSAGES.player_no_money)
					elseif (OPERATION_STATE.fail_reason 				== FAIL_REASON.player_no_space)				then
						Player:SendMessage(MESSAGES.player_no_space)
					end
					return false
				else
					-- means that there were no obstacles other than no items in chest at all
					Player:SendMessage(MESSAGES.no_items_in_shop)
					return false
				end
			end
		end
	end
	return false
end